clear all
%O[oϐ
global node;        %[
global cw;          %ReVEBhE 
global MAX_RETX;    %őđ
global DATA_S;
global Ts;
global Tc;
global PAYLOAD;

cw=16; 

%Setting system parameters based on IEEE 802.11a
D_MBPS				= 54;								% DATA RATE[Mbps]
C_MBPS				= 24;								% ACK bit rate[Mbps]
B_MBPS				= 6;								% Control frame rate[Mbps]
PLCP_HEADER_SER		= 2 * 8;							% PLCP header[bit]
MAC_HEADER			= 24 * 8;
LLC_HEADER			= 8  * 8;
FCS					= 4  * 8;
TAIL				= 6;
OFDM_SYMBOL_D		= D_MBPS*4;										% OFDM SYMBOL RATE(DAT)[bit]
OFDM_SYMBOL_A		= C_MBPS*4;										% OFDM SYMBOL RATE(ACK)[bit]
PREAMBLE_LENGTH = 16;
PLCP_HEADER_SIG = 1;
MAX_RETX=7;
DIFS = 34;
SIFS = 16;

PAYLOAD  = 1000; %yC[hTCY
MAX_NODE = 30;  %ő[

%f[^M
DATA  = (PREAMBLE_LENGTH + (PLCP_HEADER_SIG + round((PLCP_HEADER_SER + MAC_HEADER + LLC_HEADER + (PAYLOAD) * 8 +FCS)/ OFDM_SYMBOL_D)) * 4);
H =  (PREAMBLE_LENGTH + (PLCP_HEADER_SIG + round((PLCP_HEADER_SER + MAC_HEADER + LLC_HEADER)/ OFDM_SYMBOL_D)) * 4);

%yC[h̑M
PAY  = (round(((PAYLOAD) * 8 +FCS +TAIL )/ OFDM_SYMBOL_D)) * 4;

%ACKM
ACK  = (PREAMBLE_LENGTH + (PLCP_HEADER_SIG + (PLCP_HEADER_SER + 80 + FCS)/OFDM_SYMBOL_A) * 4);
RTS = 16 + (4 + round((20*8)/ B_MBPS))  ;
CTS = 16 + (4 + round((20*8)/ B_MBPS))  ;

%1t[̑M
Ts=34+DATA+16+ACK;
Tc=DATA+34+16+ACK;

%w RTS
%Ts= 34 +  RTS + 3 * SIFS + CTS + DATA + ACK;
%Tc= 34 +  RTS + SIFS;
DATA_S = round(DATA/9);

DIM=2;      %m̌
x0 = ones(1,DIM) * 0.1;     %l̐ݒ
x = x0;
itr = 1;
for cw = [8,16,32,64,128]
    
for node = 1:1:MAX_NODE
    
fun = @equation;
x = newton(fun,x);

tau(node,itr)=x(1);
gamma(node,itr)=x(2);
E(node,itr) = CalcThroughput(tau(node));
end
itr = itr +1;
end

node = 1:MAX_NODE;
node = node';
Thr = CalcThroughput(tau);
%E = [node' E']
Thr = [node Thr];

cw = [8,16,32,64,128];

% }̍쐬 
% X[vbg
figure(1);
plot(Thr(:,1),Thr(:,2),Thr(:,1),Thr(:,3),Thr(:,1),Thr(:,4),Thr(:,1),Thr(:,5),Thr(:,1),Thr(:,6),'LineWidth',1.5)
axis([0 30 0 40])
axis square
set( gca, 'FontName','Times','FontSize',22 );
ax=gca;
ax.LineWidth = 1.5; 
ax.Color = 'none';  
titlename = 'W = ' + string(cw); 
%title(titlename)
xlabel( 'Number of STAs {\it n}', 'FontName','Times','FontSize',22 ); 
ylabel( 'Saturation throughput (Mbps)', 'FontName','Times','FontSize',22 ); 
legend(titlename,'location','southeast')
movegui(figure(1),'northwest');
saveas(gca,'throughput','epsc')

% 
% Փ˗
figure(2);
plot(node,gamma(:,1),node,gamma(:,2),node,gamma(:,3),node,gamma(:,4),node,gamma(:,5),'LineWidth',1.5)
axis([0 30 0 1])
axis square
set( gca, 'FontName','Times','FontSize',22 );
ax=gca;
ax.LineWidth = 1.5; % 
ax.Color = 'none';  %
xlabel( 'Number of STAs {\it n}', 'FontName','Times','FontSize',22 ); 
ylabel( 'Colision Probability {\it \gamma}', 'FontName','Times','FontSize',22 ); 
legend(titlename,'location','northwest')
movegui(figure(2),'north');
saveas(gca,'collision','epsc')

%
%  Mm
figure(3);
plot(node,tau(:,1),node,tau(:,2),node,tau(:,3),node,tau(:,4),node,tau(:,5),'LineWidth',1.5)
axis([0 30 0 1])
axis square
set( gca, 'FontName','Times','FontSize',22 );
ax=gca;
ax.LineWidth = 1.5; 
ax.Color = 'none';  
xlabel( 'Number of STAs {\it n}', 'FontName','Times','FontSize',22 ); 
ylabel( 'Transmission probability {\it \tau}', 'FontName','Times','FontSize',22 ); 
legend(titlename,'location','northeast')
movegui(figure(3),'northeast');
saveas(gca,'tau','epsc')
